/** FileListExplorer (JavaBeans)
 *  @version 1.0
 *  @author VOURIOT Thierry
 *  @email thierry.vouriot@free.fr
 */

import tvouriot.beans.filelistexplorer.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

/** Programme de test du JavaBeans FileListExplorer */
public class TestFileListExplorer extends JFrame implements FileListExplorerListener {
    
    public JLabel lblFileSelected = new JLabel(" ");
    public JLabel lblFileChoosen = new JLabel(" ");
    public JLabel lblDirectoryChanged = new JLabel(" ");
    FileListExplorer fl = new FileListExplorer();
    
    public TestFileListExplorer() {
        HashMap hm = new HashMap();
        
        JPanel pnl = new JPanel(new BorderLayout());
        
        this.setSize(200,400);
        this.setTitle("TestFileListExplorer");
        
        hm.put(".TXT",this.getClass().getResource("middle.gif"));
        fl.setSpecialIcons(hm);
        fl.addFileListExplorerListener(this);
        
        fl.setFileIcon(this.getClass().getResource("t1.gif"));
        fl.setDirectoryIcon(this.getClass().getResource("t2.gif"));
        fl.setRefreshIcon(this.getClass().getResource("t3.gif"));
        fl.setParentIcon(this.getClass().getResource("t4.gif"));
        fl.setRootIcon(this.getClass().getResource("t5.gif"));
        
        pnl.add(lblFileSelected,BorderLayout.NORTH);
        pnl.add(lblFileChoosen,BorderLayout.CENTER);
        pnl.add(lblDirectoryChanged,BorderLayout.SOUTH);
        
        Container contentPane = this.getContentPane();
        contentPane.setLayout(new BorderLayout());
        contentPane.add(new JScrollPane(fl),BorderLayout.CENTER);
        contentPane.add(pnl,BorderLayout.SOUTH);
        
        this.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });      
    }
    
    public static void main(String args[]) {
        new TestFileListExplorer().show();
    }
    
    public void fileSelected(FileListExplorerEvent evt) {
        lblFileSelected.setForeground(Color.red);
        if (evt.getSelectedFile() != null)
            lblFileSelected.setText(evt.getSelectedFile().getPath());
        else lblFileSelected.setText(" ");
    }
    
    public void fileChoosen(FileListExplorerEvent evt) {
        lblFileChoosen.setForeground(Color.green);
        lblFileChoosen.setText(evt.getSelectedFile().getPath());
    }
    
    public void directoryChanged(FileListExplorerEvent evt) {
        lblDirectoryChanged.setForeground(Color.blue);
        if (evt.getCurrentDirectory() != null)
            lblDirectoryChanged.setText(evt.getCurrentDirectory().getPath());
        else lblDirectoryChanged.setText("Roots");       
        System.out.println("Nombre de fichiers = "+fl.getNbFiles());
        System.out.println("Nombre de sous-rpertoires = "+fl.getNbDirectories());        
    }
}