/*
 * 10/10/2001 - 20:50:39
 *
 * FileListExplorerBeanInfo
 * Copyright (C) 2001 Vouriot Thierry
 * thierry.vouriot@free.fr
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package tvouriot.beans.filelistexplorer;

import java.beans.*;

/** Classe permettant de spcifier explicitement les proprits, les vnements, les mthodes du bean.
 */
public class FileListExplorerBeanInfo extends SimpleBeanInfo {
    
    /** Icone reprsentant le bean (Color, Dim16X16)
     */    
    private static java.awt.Image iconColor16 = null;
    /** Icone reprsentant le bean (Color, Dim32X32)
     */    
    private static java.awt.Image iconColor32 = null;
    /** Icone reprsentant le bean (Mono, Dim16X16)
     */    
    private static java.awt.Image iconMono16 = null;
    /** Icone reprsentant le bean (Mono, Dim32X32)
     */    
    private static java.awt.Image iconMono32 = null;
    /** Chemin d'accs de l'cone <CODE>iconColor16</CODE>
     */    
    private static String iconNameC16 = "iconColor16.gif";
    /** Chemin d'accs de l'cone <CODE>iconColor32</CODE>
     */    
    private static String iconNameC32 = "iconColor32.gif";
    /** Chemin d'accs de l'cone <CODE>iconMono16</CODE>
     */    
    private static String iconNameM16 = "iconColor16.gif";
    /** Chemin d'accs de l'cone <CODE>iconMono32</CODE>
     */    
    private static String iconNameM32 = "iconColor32.gif";
    
    /** La classe du bean <CODE>FileListExplorer</CODE>
     */
    protected static final Class beanClass = FileListExplorer.class;
    
    /** Retourne la liste des proprits ditables.
     * Seules ces proprits seront visibles dans un IDE.
     * @return tableau des proprits
     */
    public PropertyDescriptor[] getPropertyDescriptors() {
        try {
            String []props = {"background","foreground","selectionBackground","selectionForeground","font","selectedIndex",
            "currentDirectory"};
            
            int nb = props.length;
            PropertyDescriptor []descs = new PropertyDescriptor[nb];
            for (int i=0;i<nb;i++) {
                descs[i] = new PropertyDescriptor(props[i], beanClass);
            }
            return descs;
        }
        catch (IntrospectionException ex) {
            return super.getPropertyDescriptors();
        }
    }
    
    /** Retourne l'icne reprsentant le bean dans une bote  outils
     * @param iconKind type d'cone (Color,Mono,32X32,16X16,...)
     * @return cone 16x16: <IMG src='icon16.gif'> 32x32:<IMG src='icon32.gif'>
     */
    public java.awt.Image getIcon(int iconKind) {
        switch ( iconKind ) {
            case ICON_COLOR_16x16:
                if ( iconNameC16 == null )
                    return null;
                else {
                    if( iconColor16 == null )
                        iconColor16 = loadImage( iconNameC16 );
                    return iconColor16;
                }
            case ICON_COLOR_32x32:
                if ( iconNameC32 == null )
                    return null;
                else {
                    if( iconColor32 == null )
                        iconColor32 = loadImage( iconNameC32 );
                    return iconColor32;
                }
            case ICON_MONO_16x16:
                if ( iconNameM16 == null )
                    return null;
                else {
                    if( iconMono16 == null )
                        iconMono16 = loadImage( iconNameM16 );
                    return iconMono16;
                }
            case ICON_MONO_32x32:
                if ( iconNameM32 == null )
                    return null;
                else {
                    if( iconMono32 == null )
                        iconMono32 = loadImage( iconNameM32 );
                    return iconMono32;
                }
            default: return null;
        }
    }
}

